﻿Imports Intergraph.GeoMedia
Imports Intergraph.GeoMedia.GDO
Imports Intergraph.GeoMedia.PBasic

Public Class AfegirAlcades
    Public objMV As Object
    Public objCS As PCSS.CoordSystem
    Public objGSS As PClient.GeometryStorageService
    Public objTbl As GTableDef
    Public objFld As GField
    Public objDB As GDatabase
    Public objRSInput As GDO.GRecordset
    Public objRSOutput As GDO.GRecordset
    Dim tipusAlsada As Integer
    Dim alsadaMinima As Double
    Dim alsadaMaxima As Double
    Dim alsadaConstant As Double
    Private ProcesCancellat As Boolean = False

    'crea la taula Poligons3D si no existeix
    Public Function CrearTaulaPoligons3D() As Boolean

        If ExisteixTaula("Poligons3D", objDB) = True Then
            Dim Resultat As Long = MsgBox("La taula Poligons3D ja existeix. Si es procedeix s'esborraran tots els registres existents.", 49)
            If Resultat = 1 Then
                EsborraTotsElsRegistres("Poligons3D", objDB)

                Return True
            Else
                'cancel·lat per l'usuari
                Return False
            End If
        End If

        'Create table object 
        objTbl = objDB.CreateTableDef("Poligons3D")
        objTbl.Name = "Poligons3D"

        'Autonumèric
        objFld = objTbl.CreateField("ID1", GDO.GConstants.gdbLong)
        objFld.Attributes = GDO.GConstants.gdbAutoIncrField
        objTbl.GFields.Append(objFld)
        objFld = Nothing

        'Camp de text (edifici)
        objFld = objTbl.CreateField("ID_Edifici", GDO.GConstants.gdbText)
        With objFld
            .AllowZeroLength = False
            .Attributes = GDO.GConstants.gdbUpdatableField
            .Size = 80
            .Required = True
        End With
        objTbl.GFields.Append(objFld)
        objFld = Nothing

        'Geometria
        objFld = objTbl.CreateField("Geometry", GDO.GConstants.gdbSpatial)
        With objFld
            .Type = GDO.GConstants.gdbSpatial
            .SubType = GDO.GConstants.gdbAreal
            .Required = True
            'Coord System GUID determined in AddCSSRow subprocedure 
            '.CoordSystemGUID = strGUID
        End With
        objTbl.GFields.Append(objFld)
        objFld = Nothing

        'Camp de tipus polígon
        objFld = objTbl.CreateField("Tipus_Poligon", GDO.GConstants.gdbText)
        With objFld
            .AllowZeroLength = False
            .Attributes = GDO.GConstants.gdbUpdatableField
            .Size = 1
            .Required = False
        End With
        objTbl.GFields.Append(objFld)
        objFld = Nothing

        'Camp de tipus polígon
        objFld = objTbl.CreateField("Altura", GDO.GConstants.gdbDouble)
        With objFld
            .Attributes = GDO.GConstants.gdbUpdatableField
            .Name = "Altura"
            .Required = True
        End With
        objTbl.GFields.Append(objFld)
        objFld = Nothing

        'crear index amb increment i nom 
        Dim objIdx As GIndex, objIdxFld As GField

        objIdx = objTbl.CreateIndex("IDidx")

        objIdxFld = objIdx.CreateField("ID1")
        objIdx.GFields.Append(objIdxFld)
        objIdxFld = Nothing

        With objIdx
            .Name = "IDidx"
            .IgnoreNulls = False
            .Primary = True
            .Unique = True
        End With

        objTbl.GIndexes.Append(objIdx)
        objIdx = Nothing

        objDB.GTableDefs.Append(objTbl)

        Return True
    End Function

    'crea el poligon corresponent a una cara a partir de dos punts i una alçada
    Private Function afegirPoligonCara(punt1 As PBasic.point, punt2 As PBasic.point, a As Double) As PBasic.PolygonGeometry
        Dim objNouPoligon As PBasic.PolygonGeometry = New PBasic.PolygonGeometry
        afegirPunt(objNouPoligon, punt1.X, punt1.Y, punt1.Z)
        afegirPunt(objNouPoligon, punt1.X, punt1.Y, punt1.Z + a)
        afegirPunt(objNouPoligon, punt2.X, punt2.Y, punt2.Z + a)
        afegirPunt(objNouPoligon, punt2.X, punt2.Y, punt2.Z)
        afegirPunt(objNouPoligon, punt1.X, punt1.Y, punt1.Z) 'l'últim és per tancar el polígon
        Return objNouPoligon
    End Function

    'crea el polígon de la coberta a partir dels punts del polígon d'entrada i l'alçada
    Private Function afegirPoligonCoberta(objPlanta As PBasic.PolygonGeometry, a As Double) As PBasic.PolygonGeometry
        Dim objNouPoligon As PBasic.PolygonGeometry = New PBasic.PolygonGeometry
        For m As Long = 1 To objPlanta.Points.Count
            afegirPunt(objNouPoligon, objPlanta.Points.Item(m).X, objPlanta.Points.Item(m).Y, objPlanta.Points.Item(m).Z + a)
        Next
        Return objNouPoligon
    End Function

    'bucle que crea els polígons 3D d'un edifici donat i crea els registres a la taula
    Private Function AfegeixAlcadaEdifici(nom As String, a As Double) As Boolean
        Dim objEdifici As PBasic.PolygonGeometry
        Dim objNouPoligon As PBasic.PolygonGeometry
        Dim objOut As Object = Nothing
        Dim m As Long
        Dim Tipus As String

        Dim id As Long = objRSInput.GFields("ID1").Value

        On Error GoTo ErrorHandler
        objEdifici = New PBasic.PolygonGeometry
        objGSS.StorageToGeometry(objRSInput.GFields("Geometry").Value, objEdifici)

        'N+1 punts (l'últim està repetit) fa que necessitem crear N+1 polígons: les N cares més la coberta
        For m = 1 To objEdifici.Points.Count
            If m = objEdifici.Points.Count Then
                'afegint la coberta
                objNouPoligon = afegirPoligonCoberta(objEdifici, a)
                Tipus = "C"
            Else
                'afegint cara
                objNouPoligon = afegirPoligonCara(objEdifici.Points.Item(m), objEdifici.Points.Item(m + 1), a)
                If m = 1 Then Tipus = "F" Else Tipus = "A"
            End If
            objRSOutput.AddNew()
            objGSS.GeometryToStorage(objNouPoligon, objOut)
            objRSOutput.GFields("Geometry").Value = objOut
            objRSOutput.GFields("ID_Edifici").Value = nom
            objRSOutput.GFields("Altura").Value = a
            objRSOutput.GFields("Tipus_Poligon").Value = Tipus
            objNouPoligon = Nothing
            objOut = Nothing
            objRSOutput.Update()
        Next

        objEdifici = Nothing

        Return True

ErrorHandler:  'no afegim l'edifici
        If Err.Number <> 0 Then
            'Call MsgBox("Error en importar geometria. Descartant edifici. Error: " & Err.Description, vbOKOnly + vbExclamation)
            Return False
        End If
    End Function

    'funció per a controlar si l'usuari cancel·la el càlcul
    Private Sub Button1_Click(sender As Object, e As EventArgs)
        MsgBox("Procés cancel·lat per l'usuari!")
        ProcesCancellat = True
    End Sub


    'funció principal que fa el càlcul per a cada edifici dins la taula
    Public Sub AfegeixAlcades()
        'accedint a la base de dades
        Dim objConnect As PClient.Connection
        objConnect = objGeoApp.Document.Connections(1)
        objDB = objConnect.Database

        'comprobant que la taula Poligons2D existeix
        If ExisteixTaula("Poligons2D", objDB) = False Then
            MsgBox("La Taula Poligons2D dels edificis no s'ha trobat a la base de dades. Has de crearla primer a partir d'un fitxer de formes. Operació cancel·lada.", MsgBoxStyle.Exclamation)
            Return
        End If

        'Crear segona taula pels polígons 3D
        If CrearTaulaPoligons3D() = False Then Return

        objRSInput = objDB.OpenRecordset("Poligons2D", GDO.GConstants.gdbOpenDynaset)
        objRSOutput = objDB.OpenRecordset("Poligons3D", GDO.GConstants.gdbOpenDynaset)

        'per saber el número de registres hem d'anar a l'últim primer!
        objRSInput.MoveLast()
        Dim nEdificis As Integer = objRSInput.RecordCount
        objRSInput.MoveFirst()

        Dim progressBar As New MyProgressBar(nEdificis, "Afegint alçades. ")
        AddHandler progressBar.Button1.Click, AddressOf Me.Button1_Click
        progressBar.Show()

        Dim altura As Long
        Dim count As Long
        count = 0
        Randomize()
        Dim n As Long = 0
        Do While Not objRSInput.EOF
            'barra de progrés
            progressBar.Valor(n)

            ' If n > 700 And n < 900 Then

            If objRSInput.GFields("CAS").Value = "EDI01" Then 'ha de ser del tipus vàlid com a edifici, que es EDI01
                If tipusAlsada = 0 Then altura = CDbl(Int((alsadaMaxima - alsadaMinima) * Rnd() + alsadaMinima)) Else altura = alsadaConstant
                If AfegeixAlcadaEdifici("Edifici" + Convert.ToString(count + 1), altura) = True Then count = count + 1
            End If
            'End If
            objRSInput.MoveNext()
            n = n + 1

            'per a permetre que l'usuari cancel·li el càlcul
            System.Windows.Forms.Application.DoEvents()
            If ProcesCancellat = True Then Exit Do
        Loop

        'CreateMeta()

        progressBar.Acabar(text:=" " + Convert.ToString(count) & " edificis afegits.")
        progressBar.Close()

    End Sub

    'constructor
    Public Sub New(tipusAlsada_ As Integer, alsadaMinima_ As Double, alsadaMaxima_ As Double, alsadaConstant_ As Double)
        objMV = objGeoApp.ActiveWindow.MapView
        objCS = objMV.CoordSystemsMgr.CoordSystem
        objGSS = New PClient.GeometryStorageService

        tipusAlsada = tipusAlsada_
        alsadaMinima = alsadaMinima_
        alsadaMaxima = alsadaMaxima_
        alsadaConstant = alsadaConstant_


    End Sub
End Class
