﻿Imports Intergraph.GeoMedia
Imports Intergraph.GeoMedia.GDO
Imports Intergraph.GeoMedia.PBasic

Public Class LlumSolar
    Public Overridable Function ComandaSelect(nomEdifici As String) As String
        'polimorfisme. Per defecte escull tots els polígons de l'edifici a avaluar
        Return "Select Geometry from Poligons3D where ID_Edifici = '" + nomEdifici + "'"
    End Function

    'la funció avalua si un edifici ha de ser consierat per a ésser avaluat amb detall amb ray tracing o proporció de triangles
    Public Function EdificiValid(objEdifici As PBasic.PolygonGeometry, Dmax As Double, point As PBasic.point, psol As PBasic.point) As Boolean

        'punt central del poligon de l'edifici interferent
        Dim pCInt As PBasic.point
        pCInt = PuntCentral(objEdifici)

        'Calculem la distància entre el punt central del polígon y el punt de referencia
        Dim d1 As Double = distancia2D(pCInt, point)

        'si el punt central és més lluny, l'edifici no dóna ombra
        If d1 > Dmax Then
            pCInt = Nothing
            Return False
        End If

        'mirant si l'edifici interferet està entre el sol i l'edifici. Només al pla X-Y
        Dim d2 As Double = Math.Sqrt((psol.X) ^ 2 + (psol.Y) ^ 2)
        'distància entre edifici interferent i sol. La distància hauria de ser més petita que l'anterior
        d1 = Math.Sqrt((pCInt.X - psol.X - point.X) ^ 2 + (pCInt.Y - psol.Y - point.Y) ^ 2)

        pCInt = Nothing

        'si no ho està, llavors no cal avaluar-lo
        If d1 > d2 Then Return False

        'cal avaluar l'edifici
        Return True
    End Function


    Public Overridable Function AvaluaSolDirectePunt(punt As PBasic.point, pSol As PBasic.point, poligon As PBasic.PolygonGeometry, n As PBasic.Vector, l As PBasic.Vector, zMax As Double) As Integer
        'polimorfisme
        Return 1
    End Function

    Public Overridable Function AvaluaVectorsOrtogonals(poligon As PBasic.PolygonGeometry, pSol As PBasic.point, ByRef l As PBasic.Vector, ByRef n As PBasic.Vector) As Boolean
        'polimorfisme
        Return False
    End Function

    'avalua el sol directe per a cada punt del polígon a avaluar
    Public Sub AvaluaSolDirecte(PuntsAAvaluar As PBasic.Points, ByRef mascara As Double(), poligon As PBasic.PolygonGeometry, pSol As PBasic.point)

        Dim m As Integer
        Dim Resultat As Integer
        Dim p As PBasic.point = New PBasic.point

        'pel cas de ray tracing avaluem si els vectors són ortogonals
        'a més, en aquesta funció es calculen el vector director del pla i el vector punt-sol
        Dim n As PBasic.Vector = New PBasic.Vector
        Dim l As PBasic.Vector = New PBasic.Vector
        If AvaluaVectorsOrtogonals(poligon, pSol, l, n) = True Then Return
        Dim zMax, zMin As Double
        MaxMin(ValorCoordenada(poligon.Points, 2), zMax, zMin)

        For m = 1 To PuntsAAvaluar.Count
            Resultat = AvaluaSolDirectePunt(PuntsAAvaluar.Item(m), pSol, poligon, n, l, zMax)
            If Resultat = 0 Then
                mascara(m - 1) = 0
            End If
        Next

        p = Nothing
        l = Nothing
        n = Nothing
    End Sub

End Class

