﻿Imports Intergraph.GeoMedia
Imports Intergraph.GeoMedia.GDO
Imports Intergraph.GeoMedia.PBasic

Public Class PercentatgeSolar
    Inherits CalculSolar

    Public any As Int16
    Public mes As Int16
    Public dia As Int16
    Public hora As Int16
    Public minut As Int16

    'crea la taula PercentatgeSolar si no existeix
    Overrides Function crearTaula() As Boolean

        If ExisteixTaula("PercentatgeSolar", objDB) = True Then
            Dim objRSInput As GDO.GRecordset
            Dim valor As String = any.ToString("D4") + "/" + mes.ToString("D2") + "/" + dia.ToString("D2") + " " + hora.ToString("D2") + ":" + minut.ToString("D2") + ":00"
            objRSInput = objDB.OpenRecordset("Select * from PercentatgeSolar where Data = #" + valor + "#")
            If objRSInput.EOF = False Then
                Dim Resultat As Long = MsgBox("La taula PercentatgeSolar ja conté registres amb aquesta data. Si es procedeix s'esborraran tots els registres corresponents.", 49)
                If Resultat = 1 Then
                    EsborraRegistres(objRSInput)
                    Return True
                Else
                    'cancel·lat per l'usuari
                    objRSInput.Close()
                    Return False
                End If
            Else
                objRSInput.Close()
                'la taula existeix però no conté registres amb la data donada. Per tant, podem procedir
                Return True
            End If
        End If

        'Create table object 
        objTbl = objDB.CreateTableDef("PercentatgeSolar")
        objTbl.Name = "PercentatgeSolar"

        'Autonumèric
        objFld = objTbl.CreateField("ID1", GDO.GConstants.gdbLong)
        objFld.Attributes = GDO.GConstants.gdbAutoIncrField
        objTbl.GFields.Append(objFld)
        objFld = Nothing

        'Camp de text (edifici)
        objFld = objTbl.CreateField("ID_Edifici", GDO.GConstants.gdbText)
        With objFld
            .AllowZeroLength = False
            .Attributes = GDO.GConstants.gdbUpdatableField
            .Size = 80
            .Required = True
        End With
        objTbl.GFields.Append(objFld)
        objFld = Nothing

        'Data
        objFld = objTbl.CreateField("Data", GDO.GConstants.gdbDate)
        objTbl.GFields.Append(objFld)
        objFld = Nothing

        'Geometria
        objFld = objTbl.CreateField("Geometry", GDO.GConstants.gdbSpatial)
        With objFld
            .Type = GDO.GConstants.gdbSpatial
            .SubType = GDO.GConstants.gdbAreal
            .Required = True
        End With
        objTbl.GFields.Append(objFld)
        objFld = Nothing


        'percentatge sobre coberta
        objFld = objTbl.CreateField("pc_rad_coberta", GDO.GConstants.gdbDouble)
        With objFld
            .Required = True
        End With
        objTbl.GFields.Append(objFld)
        objFld = Nothing

        'percentatge sobre façana
        objFld = objTbl.CreateField("pc_rad_fasana", GDO.GConstants.gdbDouble)
        With objFld
            .Required = True
        End With
        objTbl.GFields.Append(objFld)
        objFld = Nothing


        'crear index amb increment i nom 
        Dim objIdx As GIndex, objIdxFld As GField

        objIdx = objTbl.CreateIndex("IDidx")

        objIdxFld = objIdx.CreateField("ID1")
        objIdx.GFields.Append(objIdxFld)
        objIdxFld = Nothing

        With objIdx
            .Name = "IDidx"
            .IgnoreNulls = False
            .Primary = True
            .Unique = True
        End With

        objTbl.GIndexes.Append(objIdx)
        objIdx = Nothing

        objDB.GTableDefs.Append(objTbl)

        Return True
    End Function

    'crea els punts sobre la coberta i la façana per a la funcionalitat percentatge solar
    Overrides Sub CreacioPunts(objCoberta As PBasic.PolygonGeometry, objFasana As PBasic.PolygonGeometry, ByRef PuntsCoberta As PBasic.Points, ByRef PuntsFasana As PBasic.Points)
        Dim Punt As PBasic.point = New PBasic.point
        Dim xMax As Double, xMin As Double
        Dim yMax As Double, yMin As Double

        'Trobant els valors màxims i mínims de la coberta
        MaxMin(ValorCoordenada(objCoberta.Points, 0), xMax, xMin)
        MaxMin(ValorCoordenada(objCoberta.Points, 1), yMax, yMin)

        Dim dx As Double = (xMax - xMin) / punts_per_costat
        Dim dy As Double = (yMax - yMin) / punts_per_costat

        Punt.Z = objCoberta.Points.Item(1).Z

        'omplint coberta
        Dim j As Long
        Dim k As Long
        Dim nOut As Long = 0
        For j = 0 To punts_per_costat - 1
            Punt.X = xMin + j * dx + dx * 0.5
            For k = 0 To punts_per_costat - 1
                Punt.Y = yMin + k * dy + dy * 0.5
                If objMath.PointInPolygon(Punt, objCoberta.Points) <> -1 Then
                    PuntsCoberta.Add(Punt)
                    nOut = nOut + 1
                End If
            Next
        Next

        'omplint façana

        'Trobant els valors màxims i mínims de la fasana
        Dim zMax, zMin As Double
        MaxMin(ValorCoordenada(objFasana.Points, 0), xMax, xMin)
        MaxMin(ValorCoordenada(objFasana.Points, 1), yMax, yMin)
        MaxMin(ValorCoordenada(objFasana.Points, 2), zMax, zMin)

        dx = (xMax - xMin) / punts_per_costat
        dy = (yMax - yMin) / punts_per_costat
        Dim dz As Double = (zMax - zMin) / punts_per_costat

        nOut = 0
        For j = 0 To punts_per_costat - 1
            Punt.Z = zMin + j * dz + dz * 0.5
            For k = 0 To punts_per_costat - 1
                Punt.X = xMin + k * dx + dx * 0.5
                Punt.Y = yMin + k * dy + dy * 0.5
                'If objMath.PointInPolygon(Punt, objFasana.Points) <> -1 Then
                PuntsFasana.Add(Punt)
                nOut = nOut + 1
                'End If
            Next
        Next
 
        Punt = Nothing
    End Sub

    'crea el registre corresponent a l'edifici del cursor actual amb els valors calculats de les màscares
    Overrides Sub AvaluaMascaraRaigSol()
        'introduir registre amb percentatge de llum solar sobre la coberta i la façana
        objRSOutput.AddNew()
        objRSOutput.GFields("ID_Edifici").Value = objRSInput.GFields("ID_Edifici").Value
        objRSOutput.GFields("Data").Value = Convert.ToString(any) + "-" + Convert.ToString(mes) + "-" + Convert.ToString(dia) + " " + Convert.ToString(hora) + ":" + Convert.ToString(minut) + ":00"
        objRSOutput.GFields("Geometry").Value = objRSInput.GFields("Geometry").Value
        objRSOutput.GFields("pc_rad_coberta").Value = Total(mascaraCoberta) / mascaraCoberta.Count * 100
        objRSOutput.GFields("pc_rad_fasana").Value = Total(mascaraFasana) / mascaraFasana.Count * 100
        objRSOutput.Update()
    End Sub

    'funcions d'inicialització de les taules
    Public Overrides Function InicialitzaTaules() As Boolean
        'obrint les altres taules necessàries
        MyBase.InicialitzaTaules()

        'comprovem que la taula Poligons3D existeixi
        'creem la taula per guardar les ombres
        If crearTaula() = False Then Return False

        'obrint taula de sortida
        objRSOutput = objDB.OpenRecordset("PercentatgeSolar", GDO.GConstants.gdbOpenDynaset)

        Return True
    End Function

    'polimorfisme: fa només el càlcul de la llum solar per a una hora
    Overrides Sub CalculaDia(PuntsCoberta As PBasic.Points, PuntsFasana As PBasic.Points, dia As Date, longitud As Double, latitud As Double, pCentre As PBasic.point)
        'inicialitzant les màscares a 1
        InicialitzaMascares()

        'cridem directament la funció que avalua el sol directe per una hora concreta
        CalculaHora(PuntsCoberta, PuntsFasana, dia.Year, dia.Month, dia.Day, hora, minut, longitud, latitud, pCentre)
    End Sub

    'comprova que l'hora d'entrada estigui dins les hores de l'ortus i l'ocàs
    Private Function ComprovaOrtusOcas() As Boolean
        Dim objRSInput As GDO.GRecordset
        'seleccionem només el primer registre
        objRSInput = objGeoApp.Document.Connections(1).Database.OpenRecordset("Select top 1 * from Poligons3D where Tipus_Poligon = 'C'")
        'obtenint polígon corresponent a la coberta
        Dim objCoberta As PBasic.PolygonGeometry = New PBasic.PolygonGeometry
        objGSS.StorageToGeometry(objRSInput.GFields("Geometry").Value, objCoberta)
        objRSInput.Close()

        'obtenint el punt central de la coberta
        Dim p As PBasic.point
        p = objCoberta.Points.Item(1)
        'obtenint longitud/latitud
        'Transforma les coordenades a latitud/longitud
        objCS.TransformPoint(PCSS.CSPointConstants.cspUOR, 1, PCSS.CSPointConstants.cspLLO, 1, p.X, p.Y, p.Z)
        Dim longitud As Double = p.X * 180 / Math.PI
        Dim latitud As Double = p.Y * 180 / Math.PI

        p = CalculaAzimutAltitud(any, mes, dia, hora, minut, longitud, latitud)
        If p.X = 0 Then Return False

        Return True
    End Function

    'funció principal per a fer el càlcul
    Public Sub Calcula()
        Dim HoraActual As DateTime = New DateTime(any, mes, dia, hora, minut, 0, 0)

        'Primer comprobem que la taula Poligons3D existeixi a la base de dades
        If ExisteixTaula("Poligons3D", objGeoApp.Document.Connections(1).Database) = False Then
            MsgBox("La Taula Poligons3D no s'ha trobat a la base de dades. Has de crearla primer amb la utilitat 'Afegir alçades'. Operació cancel·lada.", MsgBoxStyle.Exclamation)
            Return
        End If

        'Seguidament mirem que l'hora donada sigui vàlida
        If ComprovaOrtusOcas() = False Then Return

        'Cridem la funció principal, la qual només farà un únic dia
        CalculaPeriode(HoraActual, HoraActual)
    End Sub

    'constructor
    Public Sub New(any_ As Int16, mes_ As Int16, dia_ As Int16, hora_ As Int16, minuts_ As Int16, radi_ As Double, punts_ As Int16, algorisme_ As Long)
        MyBase.New(algorisme_)

        any = any_
        mes = mes_
        dia = dia_
        radi = radi_
        hora = hora_
        minut = minuts_
        punts_per_costat = punts_
    End Sub


End Class

