﻿Imports Intergraph.GeoMedia
Imports Intergraph.GeoMedia.GDO
Imports Intergraph.GeoMedia.PBasic

Public Class ProporcioTriangles
    Inherits LlumSolar

    Public Overrides Function ComandaSelect(nomEdifici As String) As String
        'per l'algorisme de proporció de triangles sel·leccionem només la coberta
        Return "Select Geometry from Poligons3D where ID_Edifici = '" + nomEdifici + "'  and Tipus_Poligon = 'C'"
    End Function

    'avalua si l'edifici és a sobre la recta entre el sol i el punt a avaluar
    Public Function EdifciSobreRecta(psol As PBasic.point, point As PBasic.point, punts As PBasic.Points) As Boolean
        'calculem si el punt és sobre la línia recta entre el sol i el punt mig de l'edifici
        'això ho fem amb el producte vectorial avalant cadascuna dels punts del polígon 
        Dim v1 As PBasic.Vector = New PBasic.Vector
        Dim v2 As PBasic.Vector = New PBasic.Vector
        Dim v3 As PBasic.Vector = New PBasic.Vector
        v1.I = -psol.X
        v1.J = -psol.Y
        v1.K = 0 'forcem z = 0

        Dim p As PBasic.point = New PBasic.point

        Dim zs(punts.Count - 2) As Double
        For m As Long = 1 To punts.Count - 1 'l'últim punt està repetit i no cal avaluar-lo
            p.X = punts.Item(m).X - point.X
            p.Y = punts.Item(m).Y - point.Y
            v2 = objMath.BuildVector(psol, p) 'vector p - psol
            v2.K = 0 'forcem z=0
            v3 = objMath.CrossProduct(v2, v1)
            zs(m - 1) = v3.K
        Next
        p = Nothing
        v1 = Nothing
        v2 = Nothing
        v3 = Nothing

        'per a que l'edifici creui la recta entre el sol i el punt ha d'haver-hi valors de Z positius i negatius
        Dim zMax, zMin As Double
        MaxMin(zs, zMax, zMin)
        If zMin < 0 And zMax > 0 Then Return True

        Return False
    End Function

    'la funció avalua si un polígon dóna ombra o no al punt de referència fent servir l'algorisme de proporció de triangles
    Public Overrides Function AvaluaSolDirectePunt(punt As PBasic.point, pSol As PBasic.point, poligon As PBasic.PolygonGeometry, n As PBasic.Vector, l As PBasic.Vector, zMax As Double) As Integer
        'Càlcul amb proporció de triangles

        'diferència d'alçades entre l'edifici interferent i el punt d'interès
        'el polígon és de la coberta, així que tots els punts són a la mateixa alçada
        Dim hDif = poligon.Points.Item(1).Z - punt.Z

        'en primer lloc avaluem si el polígon és més baix que el punt que s'està avaluant
        'si ho és, no li pot fer ombra
        If hDif < 0 Then Return 1

        'primer avaluem si l'edifci es troba sobre la recta que uneix el sol i el punt
        If EdifciSobreRecta(pSol, punt, poligon.Points) = False Then Return 1

        'Calculem la distància de tots els punts del polígon respecte al punt de referència i ens quedem amb la més petita
        Dim dist As Double
        Dim minDist As Double = 1000000
        Dim m As Long
        For m = 1 To poligon.Points.Count
            dist = distancia(punt, poligon.Points.Item(m))
            If dist < minDist Then minDist = dist
        Next

        'Distància al pla X-Y del sol al punt de referència al terra
        Dim dSol As Double = distancia2D(punt, pSol)

        'alçada del sol respecte al punt de referència
        Dim hsol As Double = pSol.Z - punt.Z

        'calculant alçada mínima de l'edifici interferent fent servir proporció de triangles
        Dim hMin As Double = minDist / dSol * hsol

        'si la diferència d'alçades és més petita que la mínima que es requereix, llavors el punt rep llum directa del sol
        If hDif < hMin Then Return 1 Else Return 0
    End Function


End Class
